# How to update css
`npm install -g less`
`lessc less/pfpmd.less dist/bundle.css`
# Installation instructions
## Install pfpmd_ui3
Build (from the directory where this README.md file is located):

`$ cargo build --release`

Move pfpmd_ui3 files to `/var/www/pfpmd_ui3`:
```
$ sudo mkdir /var/www/pfpmd_ui3
$ sudo cp -f ~/pfpmd_ui3/target/release/pfpmd_ui3 /var/www/pfpmd_ui3
$ sudo rsync -avuh ~/pfpmd_ui3/config /var/www/pfpmd_ui3/
$ sudo rsync -avuh ~/pfpmd_ui3/templates /var/www/pfpmd_ui3/
```

The config file is in `/var/www/pfpmd_ui3/config/default.toml`.

### Create pfpmd_ui3 service
```
sudo rsync -avhu ~/pfpmd_ui3/pfpmd_ui3.service /home/pfpmd/.config/systemd/user/
sudo chown pfpmd:pfpmd /home/pfpmd/.config/systemd/user/pfpmd_ui3.service
```

For logging, create file `/etc/rsyslog.d/pfpmd_ui3.conf` and add:
```
if $programname == 'pfpmd_ui3' then /var/log/pfpmd/pfpmd_ui3.log
& stop
```
Restart `rsyslog`:
```
sudo systemctl restart rsyslog.service
```
Enable and start the service:
```
sudo -u pfpmd XDG_RUNTIME_DIR="/run/user/$(id -u pfpmd)" systemctl --user enable pfpmd_ui3
sudo -u pfpmd XDG_RUNTIME_DIR="/run/user/$(id -u pfpmd)" systemctl --user start pfpmd_ui3
```

Restart nginx
```
$ sudo systemctl restart nginx
```
