use crate::settings::DbSettings;

pub fn open_db(db_settings: &DbSettings) -> sled::Result<sled::Db> {
    let config = sled::Config::default()
        .path(db_settings.path.clone())
        .cache_capacity(db_settings.cache_capacity)
        .use_compression(db_settings.use_compression)
        .compression_factor(db_settings.compression_factor)
//        .temporary(db_settings.temporary)
        ;

    config.open()
}