base_path = '/ui3'
base_url = f'http://127.0.0.1:8585{base_path}'

schemas = {
    "clientId": {
        "description": "This is used to generate colors.",
        "type": "string",
        "minLength": 1,
        "maxLength": 32
    },
    "version": {
        "type": "string",
        "pattern": "^(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)\\.(0|[1-9][0-9]*)$",
    },
    "uiState": {
        "type": "object",
        "required": [
            "cookies",
            "version",
            "ui"
        ],
        "properties": {
            "cookies": {
                "$ref": "#/schemas/cookies"
            },
            "version": {
                "$ref": "#/schemas/version"
            },
            "ui": {
                "type": "string",
                "enum": ["ui3"]
            }
        }
    },
    "cookies": {
        "type": "object",
        "required": [
            "clientId",
            "fixMenu",
            "showThumbs",
            "maxWidth",
            "compact",
            "onlyChatPosts"
        ],
        "properties": {
            "clientId": {
                "$ref": "#/schemas/clientId"
            },
            "fixMenu": {
                "type": "boolean"
            },
            "showThumbs": {
                "type": "boolean"
            },
            "maxWidth": {
                "type": "integer",
                "minimum": 0,
            },
            "compact": {
                "type": "boolean"
            },
            "onlyChatPosts": {
                "type": "boolean"
            }
        }
    }
}
