from itertools import product
from timeit import default_timer as timer
from settings import *
import requests
import jsonschema

session = requests.Session()
session.trust_env = False
session.headers.update({'cache-control': 'no-cache'})

chat_thread_id = 'a237b4adbdbd4fa29abf1f646fdcf40a'
first_post_id = '685d68bca73a4d028981fa214f05f065'
client_id = 'zyS43j1VBu'

invalid_query = {'errorCode': 'E0400', 'message': 'Invalid query'}
not_found = {"errorCode": "E0404", "message": "Not Found"}
invalid_uints = (-1, 0x100000000, 'asdf', '18!', '', '1+2', ' 1', '0x11', '++11')
invalid_booleans = (1, 0, 'a', 'True', 'False', '')
invalid_uuids = (11, 'asfd', 'xy5cb6d3-58db-5790-afaa-3e815bf09446')
invalid_boards = ('1', 'abcd', 'b1', '*#', '$a', 'фа')
invalid_nicknames = ('1', 'administrator', 'some one', '#', 'huy', 'фыва', 'someone2', 'some_one', 'sOmEoN')


valid_nickname = 'someone'
valid_password = 'uOGghquQ5smwXtsxqfeq'


def measure_time(func):
    def inner(*args, **kwargs):
        start = timer()
        res = func(*args, **kwargs)
        end = timer()
        print(f'took: {(end - start) * 1000}ms')
        return res

    return inner


def assert_success_response(r):
    assert r.status_code == 200
    assert r.headers.get("etag")
    assert r.cookies.get("clientId") or session.cookies.get("clientId")


def assert_success_json_response(r):
    assert_success_response(r)
    assert r.headers['content-type'] == 'application/json'


def assert_permanent_redirect(r, redirect_url):
    assert r.text == ''
    assert r.status_code == 301
    assert r.headers.get("location")
    assert r.headers.get("location") == redirect_url


def assert_found(r, redirect_url=None, redirect_url_prefix=None):
    assert r.text == ''
    assert r.status_code == 302
    assert r.headers.get("location")
    if redirect_url_prefix is None:
        if redirect_url is not None:
            assert r.headers["location"] == redirect_url
    else:
        assert r.headers["location"].startswith(redirect_url_prefix)


def assert_unauthorized(r):
    assert r.status_code == 200
    assert 'Unauthorized. Please log in.' in r.text


def assert_not_found(r):
    assert r.status_code == 200
    assert 'Not Found' in r.text


def get_schema(name):
    s = schemas[name].copy()
    s['schemas'] = schemas
    return s


def validate_schema(r, name):
    jsonschema.validate(r.json(), get_schema(name))