from shared import *


def get_board_page(board='b', params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/{board}", params=params)
    print(f"GET {r.url}")
    return r


def test_get_board_page():
    r = get_board_page()
    assert_success_response(r)

    r = get_board_page(params={'p': '12'})
    assert_success_response(r)

    # non existing page is ok
    r = get_board_page(params={'p': '12000'})
    assert_success_response(r)

    r = get_board_page(params={'other': 'param'})
    assert_success_response(r)

    # not existing boards are ok
    r = get_board_page('bcr')
    assert_success_response(r)

    r = get_board_page('bcr', params={'p': '12'})
    assert_success_response(r)


def test_get_board_page_errors():
    for p in invalid_uints:
        r = get_board_page(params={'p': p})
        assert r.status_code == 400

    for board_name in invalid_boards:
        r = get_board_page(board_name)
        assert r.status_code == 404

    r = session.post(f"{base_url}/b")
    print(f"POST {r.url}")
    assert r.status_code == 405
