from shared import *


def get_boards_page(params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/boards", params=params)
    print(f"GET {r.url}")
    return r


def test_get_boards_page():
    r = get_boards_page()
    assert_success_response(r)

    r = get_boards_page({'p': '12'})
    assert_success_response(r)

    # non existing page is ok
    r = get_boards_page(params={'p': '12000'})
    assert_success_response(r)

    r = get_boards_page({'other': 'param'})
    assert_success_response(r)


def test_get_boards_page_errors():
    for p in invalid_uints:
        r = get_boards_page({'p': p})
        assert r.status_code == 400

    r = get_boards_page({'other': 'param' * 2000})
    assert r.status_code == 414

    r = session.post(f"{base_url}/boards")
    print(f"POST {r.url}")
    assert r.status_code == 405
