from shared import *


def get_chat_page(params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/chat", params=params)
    print(f"GET {r.url}")
    return r


def test_get_chat_page():
    r = get_chat_page()
    assert_success_response(r)

    r = get_chat_page({'p': '12', 'other': 'param'})
    assert_success_response(r)

    for p in invalid_uints:
        r = get_chat_page({'p': p})
        assert_success_response(r)


def test_get_chat_page_errors():
    r = get_chat_page({'other': 'param' * 2000})
    assert r.status_code == 414

    r = session.post(f"{base_url}/chat")
    print(f"POST {r.url}")
    assert r.status_code == 405
