from shared import *
from test_boards_page import get_boards_page


def get_export(params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/pfpmd_ui3_settings.json", params=params)
    print(f"GET {r.url}")
    return r


def test_get_export_page():
    get_boards_page(clear_cookies=False)

    print(session.cookies)

    r = get_export(clear_cookies=False)
    print(r.json())

    assert_success_json_response(r)
    validate_schema(r, 'uiState')

    r = get_export({'p': '12', 'other': 'param'}, clear_cookies=False)
    assert_success_json_response(r)
    validate_schema(r, 'uiState')

    for p in invalid_uints:
        r = get_export({'p': p}, clear_cookies=False)
        assert_success_json_response(r)
        validate_schema(r, 'uiState')


def test_get_export_errors():
    r = get_export({'other': 'param' * 2000})
    assert r.status_code == 414

    r = session.post(f"{base_url}/import")
    print(f"POST {r.url}")
    assert r.status_code == 405
