from shared import *


def get_login_page(params=None, referrer=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()

    headers = {'Referer': referrer} if referrer else None

    r = session.get(f"{base_url}/login", params=params, headers=headers)
    print(f"GET {r.url}")
    return r


def test_get_login_page():
    r = get_login_page()
    assert_success_response(r)

    # with or without referrer - ok
    r = get_login_page(referrer="/test")
    assert_success_response(r)

    r = get_login_page({'p': '12', 'other': 'param'})
    assert_success_response(r)

    for p in invalid_uints:
        r = get_login_page({'p': p})
        assert_success_response(r)


def test_get_login_page_errors():
    r = session.post(f"{base_url}/login")
    print(f"POST {r.url}")
    assert r.status_code == 405
