from shared import *


def get_post_page(post_id=first_post_id, params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/@/{post_id}", params=params, allow_redirects=False)
    print(f"GET {r.url}")
    return r


def test_get_post_page():
    redirect_url = f"{base_path}/cht/{chat_thread_id}?p=0#{first_post_id}"

    r = get_post_page()
    print(r.headers.get("location"))
    assert_permanent_redirect(r, redirect_url)

    r = get_post_page(params={'p': '12'})
    assert_permanent_redirect(r, redirect_url)

    r = get_post_page(params={'other': 'param'})
    assert_permanent_redirect(r, redirect_url)


def test_get_post_page_errors():
    for post_id in invalid_uuids:
        r = get_post_page(post_id)
        assert r.status_code == 404

    r = session.post(f"{base_url}/@/{first_post_id}")
    print(f"POST {r.url}")
    assert r.status_code == 405
