from shared import *


def get_thread_page(board_name='cht', thread_id=chat_thread_id, params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/{board_name}/{thread_id}", params=params)
    print(f"GET {r.url}")
    return r


def test_get_thread_page():
    r = get_thread_page()
    assert_success_response(r)

    r = get_thread_page(params={'p': '12'})
    assert_success_response(r)

    # non existing page is ok
    r = get_thread_page(params={'p': '12000'})
    assert_success_response(r)

    r = get_thread_page(params={'other': 'param'})
    assert_success_response(r)

    # not existing boards are ok
    r = get_thread_page('bcr')
    assert_success_response(r)

    r = get_thread_page('bcr', params={'p': '12'})
    assert_success_response(r)


def test_get_thread_page_errors():
    for p in invalid_uints:
        r = get_thread_page(params={'p': p})
        assert r.status_code == 400

    for board_name in invalid_boards:
        r = get_thread_page(board_name, chat_thread_id)
        assert r.status_code == 404

    for thread_id in invalid_uuids:
        r = get_thread_page(thread_id=thread_id)
        assert r.status_code == 404

    r = session.post(f"{base_url}/b")
    print(f"POST {r.url}")
    assert r.status_code == 405
