from shared import *


def get_warp_page(params=None, clear_cookies=True):
    if clear_cookies:
        session.cookies.clear()
    r = session.get(f"{base_url}/", params=params)
    print(f"GET {r.url}")
    return r


def test_get_warp_page():
    r = get_warp_page()
    assert_success_response(r)

    r = get_warp_page(params={'p': '12'})
    assert_success_response(r)

    # non existing page is ok
    r = get_warp_page(params={'p': '12000'})
    assert_success_response(r)

    r = get_warp_page(params={'other': 'param'})
    assert_success_response(r)


def test_get_warp_page_errors():
    for p in invalid_uints:
        r = get_warp_page(params={'p': p})
        assert r.status_code == 400

    r = session.post(f"{base_url}/")
    print(f"POST {r.url}")
    assert r.status_code == 405
